
User Interface - Bug #2713

Bug # 2677 (New): fix drawing and functional differences between P2J GUI and 4GL GUI

Incorrect labels in case of the overlapping widgets.

09/14/2015 04:28 PM - Igor Skornyakov

Status: WIP Start date:  

Priority: Low Due date:  

Assignee: Constantin Asofiei % Done: 0%

Category:  Estimated time: 0.00 hour

Target version:    

billable: No case_num:  

vendor_id: GCD   

Description

History

#1 - 09/14/2015 04:32 PM - Igor Skornyakov

- File zr.p added

If two widgets (f and g FILL-IN in the attached program) are overlapped then with 4GL only the label of the topmost widget is visible and this doesn't

change even after the Z-order is changed via MOVE-TO-TOP()/MOVE-TO-BOTTON() methods. With p2j both lables are 'half-visible'.

#2 - 09/14/2015 05:08 PM - Greg Shah

- Project changed from Runtime Infrastructure to User Interface

#3 - 09/14/2015 05:08 PM - Greg Shah

- Start date deleted (09/14/2015)

- Parent task set to #2677

#4 - 10/20/2015 07:13 AM - Constantin Asofiei

- Status changed from New to WIP

- Assignee set to Constantin Asofiei

#5 - 10/20/2015 01:51 PM - Constantin Asofiei

- File label-z-order_header.png added

The issue is more complex than just z-order.  When computing the top-label layout for a case when widgets intersect (on X and Y), the order of the

labels is somehow "undefined":

DEFINE VARIABLE f AS CHAR FORMAT "X(20)"  NO-UNDO VIEW-AS FILL-IN.

DEFINE VARIABLE g AS CHAR FORMAT "X(10)"  NO-UNDO VIEW-AS FILL-IN.

DEFINE VARIABLE j AS CHAR FORMAT "X(10)"  NO-UNDO VIEW-AS FILL-IN.

DEFINE VARIABLE h AS CHAR FORMAT "X(10)"  NO-UNDO VIEW-AS FILL-IN.

DEF FRAME fr 

   f  AT COLUMN 1 ROW 3 BGCOLOR 1 

   g  AT COLUMN 1 ROW 3 BGCOLOR 3

   h  AT COLUMN 1 ROW 1 BGCOLOR 1

   j  AT COLUMN 1 ROW 1 BGCOLOR 3

  WITH TITLE "fr" AT COLUMN 1 ROW 1 SIZE 40 BY 12.

ENABLE ALL WITH FRAME fr.
WAIT-FOR WINDOW-CLOSE OF CURRENT-WINDOW.

 

    

Even if j and h are set for row 1, they are well bellow this row.  The order gets even weird if more widgets are added and the same row is used in misc

cases.

Can we make this a low priority? I think the numeric format/selection issue #2727 is more important.

#6 - 10/20/2015 01:53 PM - Greg Shah

- Priority changed from Normal to Low

Yes, this is not critical right now.

Files

zr.p 346 Bytes 09/14/2015 Igor Skornyakov

label-z-order_header.png 2.35 KB 10/20/2015 Constantin Asofiei
